#region Copyright Syncfusion Inc. 2001 - 2005
//
//  Copyright Syncfusion Inc. 2001 - 2005. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Re-distribution in any form is strictly
//  prohibited. Any infringement will be prosecuted under applicable laws. 
//
#endregion

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.XlsIO;

namespace EssentialXlsIOSamples
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.DataGrid dataGrid1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.button1 = new System.Windows.Forms.Button();
			this.dataGrid1 = new System.Windows.Forms.DataGrid();
			((System.ComponentModel.ISupportInitialize)(this.dataGrid1)).BeginInit();
			this.SuspendLayout();
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(592, 616);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(96, 23);
			this.button1.TabIndex = 0;
			this.button1.Text = "Read XLS";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// dataGrid1
			// 
			this.dataGrid1.DataMember = "";
			this.dataGrid1.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.dataGrid1.Location = new System.Drawing.Point(32, 24);
			this.dataGrid1.Name = "dataGrid1";
			this.dataGrid1.Size = new System.Drawing.Size(656, 560);
			this.dataGrid1.TabIndex = 1;
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(728, 662);
			this.Controls.Add(this.dataGrid1);
			this.Controls.Add(this.button1);
			this.Name = "Form1";
			this.Text = "Essential XlsIO Samples";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.dataGrid1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		
		private void button1_Click(object sender, System.EventArgs e)
		{
			try
			{
			// New instance of XlsIO is created.[Equivalent to launching MS Excel with no workbooks open].
			// The instantiation process consists of two steps.

			// Step 1 : Instantiate the spreadsheet creation engine.
			ExcelEngine excelEngine = new ExcelEngine();

			// Step 2 : Instantiate the excel application object.
			IApplication application = excelEngine.Excel;
		
			// Open an existing spreadsheet which will be used as a template for generating the new spreadsheet.
			// After opening, the workbook object represents the complete in-memory object model of the template spreadsheet.
			IWorkbook workbook = application.Workbooks.Open(@"..\..\Data\Sample.XLS"); 	
			
			// The first worksheet object in the worksheets collection is accessed.
			IWorksheet sheet = workbook.Worksheets[0];							
			// Read Data.
			//We export all the contents in the worksheet to a datatable.
			this.dataGrid1.DataSource = sheet.ExportDataTable(1,1,sheet.UsedRange.End.Row,1,ExcelExportDataTableOptions.None);	
		
			// The first cells content is also written to the textbox.
			// No exception will be thrown if there are unsaved workbooks.
			excelEngine.ThrowNotSavedOnDestroy = false;
			excelEngine.Dispose(); 
			}
			catch(Syncfusion.XlsIO.Implementation.Exceptions.LockShareViolationException arg)
			{
				MessageBox.Show("Note:Please edit the excel file,then save it and Close\n Plesae Click the 'ReadXLS'button after closing the Excel file");
			}

		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			//New instance of XlsIO is created.[Equivalent to launching MS Excel with no workbooks open].
			//The instantiation process consists of two steps.

			//Step 1 : Instantiate the spreadsheet creation engine.
			ExcelEngine excelEngine = new ExcelEngine();
			//Step 2 : Instantiate the excel application object.
			IApplication application = excelEngine.Excel;

			//Open an existing spreadsheet which will be used as a template for generating the new spreadsheet.
			//After opening, the workbook object represents the complete in-memory object model of the template spreadsheet.
			IWorkbook workbook = application.Workbooks.Open(@"..\..\Data\Sample.XLS"); 
			//The first worksheet object in the worksheets collection is accessed.
			IWorksheet sheet = workbook.Worksheets[0];						
			
			//Saving the contents.
			workbook.Save();
			System.Diagnostics.Process.Start(System.IO.Path.GetFullPath(@"..\..\Data\Sample.XLS"));
			
			//No exception will be thrown if there are unsaved workbooks.
			excelEngine.ThrowNotSavedOnDestroy = false;
			excelEngine.Dispose(); 
		}
	}
}
